package rocks.zipcode.quiz3a.fundamentals.calculator;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz3a.fundamentals.Calculator;

/**
 * @author leon on 01/01/2019.
 */
public class SquareRootsTest {

    @Test
    public void test1() {
        // given
        test(64.0, 81.0, 96.0, 9.0);
    }

    @Test
    public void test2() {
        // given
        test(44100.0, 86943.0, 9.0, 16.0);
    }

    @Test
    public void test3() {
        // given
        test(144.0, 72.98, 81.0);
    }

    @Test
    public void test4() {
        // given
        test(390625.0, 36.0, 64.0, 144.0);
    }

    @Test
    public void test5() {
        // given
        test(36.0, 255.0, 144.0, 81.0);
    }

    private void test(Double... inputArray) {
        // given
        Double sqRootInput;
        Double[] expected = new Double[inputArray.length];
        for(int i = 0; i < inputArray.length; i++) {
            sqRootInput = Math.sqrt(inputArray[i]);
            expected[i] = sqRootInput;
        }

        // when
        Calculator calculator = new Calculator();
        Double[] actual = calculator.squareRoots(inputArray);

        // then
        Assert.assertArrayEquals(expected, actual);
    }
}
