package rocks.zipcode.quiz3a.fundamentals.calculator;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.quiz3a.fundamentals.Calculator;

/**
 * @author leon on 01/01/2019.
 */
public class SquaresTest {
    @Test
    public void test1() {
        // given
        test(32.70, 738.08, 523.735, 837.90);
    }

    @Test
    public void test2() {
        // given
        test(689.93, 847.95, 3736.0, 8.0, 3.0);
    }

    @Test
    public void test3() {
        // given
        test(35354.0, 3.5, 7.8, 6354495875.00, 725.0);
    }

    @Test
    public void test4() {
        // given
        test(746.93774653, 2.0, 6.0, 47.0, 74.0, 838.0);
    }

    @Test
    public void test5() {
        // given
        test(99873636.94874);
    }

    private void test(Double... inputArray) {
        // given
        Double squaredInput;
        Double[] expected = new Double[inputArray.length];
        for(int i = 0; i < inputArray.length; i++) {
            squaredInput = inputArray[i] * inputArray[i];
            expected[i] = squaredInput;
        }

        // when
        Calculator calculator = new Calculator();
        Double[] actual = calculator.squares(inputArray);

        // then
        Assert.assertArrayEquals(expected, actual);
    }
}
